diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/mips/mips/vps_machdep.c head/sys/mips/mips/vps_machdep.c
--- clean-head/sys/mips/mips/vps_machdep.c	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/mips/mips/vps_machdep.c	2013-06-24 14:20:45.000000000 +0200
@@ -0,0 +1,577 @@
+/*-
+ * Copyright (c) 2009-2013 Klaus P. Ohrhallinger <k@7he.at>
+ * All rights reserved.
+ *
+ * Development of this software was partly funded by:
+ *    TransIP.nl <http://www.transip.nl/>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+static const char vpsid[] =
+    "$Id$";
+
+#include <sys/cdefs.h>
+
+#include <sys/param.h>
+#include <sys/conf.h>
+#include <sys/types.h>
+#include <sys/kernel.h>
+#include <sys/libkern.h>
+#include <sys/malloc.h>
+#include <sys/proc.h>
+#include <sys/sysent.h>
+#include <sys/sysproto.h>
+
+#include <machine/cpu.h>
+#include <machine/pcb.h>
+#include <machine/frame.h>
+#include <machine/vmparam.h>
+#include <machine/md_var.h>
+#include <machine/asm.h>
+#include <machine/trap.h>
+#include <machine/vps_md.h>
+
+#include <vm/vm.h>
+#include <vm/pmap.h>
+#include <vm/vm_page.h>
+#include <vm/vm_object.h>
+#include <vm/vm_map.h>
+
+#include <vps/vps.h>
+#include <vps/vps2.h>
+#include <vps/vps_int.h>
+#include <vps/vps_libdump.h>
+#include <vps/vps_snapst.h>
+
+#undef v0
+#undef a0
+#undef a1
+#undef a2
+#undef a3
+#undef a4
+#undef a5
+#undef a6
+#undef a7
+
+#ifdef VPS
+
+/*__attribute__((inline))*/
+void
+vps_md_print_thread(struct thread *td)
+{
+
+	DBGCORE("%s: thread %p/%d kernel stack:\n"
+		/*
+		"td->td_pcb->rsp=%016lx\n"
+		"td->td_frame->tf_rax=%016lx\n"
+		"td->td_frame->tf_rsp=%016lx\n"
+		"td->td_frame->tf_rbp=%016lx\n"
+		"td->td_frame->tf_rip=%016lx\n"
+		"trace:\n",
+		*/
+		,
+		__func__,
+		td,
+		td->td_tid
+		/*
+		td->td_pcb->pcb_rsp,
+		td->td_frame->tf_rax,
+		td->td_frame->tf_rsp,
+		td->td_frame->tf_rbp,
+		td->td_frame->tf_rip
+		*/
+		);
+}
+
+/*__attribute__((inline))*/
+int
+vps_md_restore_thread(struct vps_dump_thread *vdtd, struct thread *ntd,
+    struct proc *p)
+{
+
+	if (vps_func->vps_restore_return == NULL) {
+		printf("%s: vps_restore module not loaded ? "
+		    "vps_func->vps_restore_return == NULL",
+		    __func__);
+		return (EOPNOTSUPP);
+	}
+
+	/*
+	ntd->td_pcb->pcb_cr3 =
+	    DMAP_TO_PHYS((vm_offset_t)vmspace_pmap(p->p_vmspace)->pm_pml4);
+	ntd->td_pcb->pcb_r12 = (uint64_t)vps_func->vps_restore_return;
+	ntd->td_pcb->pcb_rbp = 0;
+	ntd->td_pcb->pcb_rsp = (uint64_t)ntd->td_frame - sizeof(void *);
+	ntd->td_pcb->pcb_rbx = (uint64_t)ntd;
+	ntd->td_pcb->pcb_rip = (uint64_t)fork_trampoline;
+	ntd->td_md.md_spinlock_count = 1;
+	ntd->td_md.md_saved_flags = PSL_KERNEL | PSL_I;
+	*/
+	ntd->td_pcb->pcb_context[PCB_REG_RA] = (register_t)(intptr_t)
+	    fork_trampoline;
+	/* Make sp 64-bit aligned */
+	ntd->td_pcb->pcb_context[PCB_REG_SP] = (register_t)(((vm_offset_t)
+	    ntd->td_pcb & ~(sizeof(__int64_t) - 1)) - CALLFRAME_SIZ);
+	ntd->td_pcb->pcb_context[PCB_REG_S0] = (register_t)(intptr_t)
+	    vps_func->vps_restore_return;
+	ntd->td_pcb->pcb_context[PCB_REG_S1] = (register_t)(intptr_t)ntd;
+	ntd->td_pcb->pcb_context[PCB_REG_S2] = (register_t)(intptr_t)
+	    ntd->td_frame;
+	ntd->td_pcb->pcb_context[PCB_REG_SR] = mips_rd_status() &
+	    (MIPS_SR_KX | MIPS_SR_UX | MIPS_SR_INT_MASK);
+	ntd->td_md.md_tls = curthread->td_md.md_tls;
+	ntd->td_md.md_saved_intr = MIPS_SR_INT_IE;
+	ntd->td_md.md_spinlock_count = 1;
+
+	/* XXX CPU_CNMIPS stuff ?! */
+
+	ntd->td_errno = vdtd->td_errno;
+	ntd->td_retval[0] = vdtd->td_retval[0];
+	ntd->td_retval[1] = vdtd->td_retval[1];
+
+	/*
+	//db_trace_thread(ntd, 10);
+	DBGCORE("%s: td_pcb = %p; td_frame = %p; pcb_rsp = %016lx\n",
+		__func__, ntd->td_pcb, ntd->td_frame, ntd->td_pcb->pcb_rsp);
+	*/
+
+	return (0);
+}
+
+/*__attribute__((inline))*/
+int
+vps_md_snapshot_sysentvec(struct sysentvec *sv, long *svtype)
+{
+	int error = 0;
+
+	if (sv == &elf64_freebsd_sysvec) {
+		DBGCORE("%s: elf64_freebsd_sysvec\n", __func__);
+		*svtype = VPS_SYSENTVEC_ELF64;
+#ifdef COMPAT_FREEBSD32
+	} else if (sv == &ia32_freebsd_sysvec) {
+		DBGCORE("%s: ia32_freebsd_sysvec\n", __func__);
+		*svtype = VPS_SYSENTVEC_ELF32;
+#endif
+	} else if (sv == &null_sysvec) {
+		DBGCORE("%s: null_sysvec\n", __func__);
+		*svtype = VPS_SYSENTVEC_NULL;
+        } else {
+		DBGCORE("%s: nknown sysentvec %p\n", __func__, sv);
+		error = EINVAL;
+        }
+
+	return (error);
+}
+
+/*__attribute__((inline))*/
+int
+vps_md_restore_sysentvec(long svtype, struct sysentvec **sv)
+{
+	int error = 0;
+
+	if (svtype == VPS_SYSENTVEC_ELF64)
+		*sv = &elf64_freebsd_sysvec;
+#ifdef COMPAT_FREEBSD32
+	else if (svtype == VPS_SYSENTVEC_ELF32)
+		*sv = &ia32_freebsd_sysvec;
+#endif
+	else if (svtype == VPS_SYSENTVEC_NULL)
+		*sv = &null_sysvec;
+	else {
+		DBGCORE("%s: unknown sysentvec type: %ld\n",
+			__func__, svtype);
+		error = EINVAL;
+	}
+
+	return (error);
+}
+
+/*__attribute__((inline))*/
+int
+vps_md_restore_checkarch(uint8 ptrsize, uint8 byteorder)
+{
+	int error;
+
+	if (ptrsize == VPS_DUMPH_64BIT && byteorder == VPS_DUMPH_MSB)
+		error = 0;
+	else
+		error = EINVAL;
+
+	return (error);
+}
+
+/*__attribute__((inline))*/
+int
+vps_md_snapshot_thread_savefpu(struct vps_snapst_ctx *ctx, struct vps *vps,
+    struct thread *td)
+{
+#if 0
+XXX
+        struct vps_dumpobj *o1;
+        struct vps_dump_savefpu *vdsf;
+
+	KASSERT(td->td_pcb != NULL && td->td_pcb->pcb_save != NULL,
+		("%s: td->td_pcb == NULL || td->td_pcb->pcb_save == NULL\n",
+		__func__));
+
+	if ((o1 = vdo_create(ctx, VPS_DUMPOBJT_SAVEFPU, M_NOWAIT)) ==
+	    NULL) {
+		vdo_discard(ctx, o1);
+		return (ENOMEM);
+	}
+
+	if ((vdsf = vdo_space(ctx, sizeof(*vdsf), M_NOWAIT)) == NULL) {
+		vdo_discard(ctx, o1);
+		return (ENOMEM);
+	}
+	vdsf->sf_length = sizeof(struct savefpu);
+
+	if (vdo_append(ctx, (void *)td->td_pcb->pcb_save, vdsf->sf_length,
+	    M_NOWAIT)) {
+		vdo_discard(ctx, o1);
+		return (ENOMEM);
+	}
+
+	vdo_close(ctx);
+#endif
+
+	return (0);
+}
+
+/*__attribute__((inline))*/
+int
+vps_md_restore_thread_savefpu(struct vps_snapst_ctx *ctx, struct vps *vps,
+    struct thread *td)
+{
+#if 0
+XXX
+	struct vps_dumpobj *o1;
+	struct vps_dump_savefpu *vdsf;
+
+	/* caller verified type. */
+	o1 = vdo_next(ctx);
+
+	vdsf = (struct vps_dump_savefpu *)o1->data;
+
+	/*
+	 * XXX Verify that we can't harm the system (kernel space)
+	 *     by restoring an invalid savefpu context.
+	 */
+	if (vdsf->sf_length != sizeof(struct savefpu)) {
+		DBGCORE("%s: vdsf->sf_length != sizeof(struct savefpu) "
+		    (%u != %lu)\n", __func__, vdsf->sf_length,
+		    sizeof(struct savefpu));
+		return (EINVAL);
+	}
+
+	KASSERT(td->td_pcb != NULL && td->td_pcb->pcb_save != NULL,
+		("%s: td->td_pcb == NULL || td->td_pcb->pcb_save == NULL\n",
+		__func__));
+
+	DBGCORE("%s: td->td_pcb->pcb_save=%p\n",
+	    __func__, td->td_pcb->pcb_save);
+	memcpy(td->td_pcb->pcb_save, vdsf->sf_data, vdsf->sf_length);
+
+#endif
+	return (0);
+}
+
+/*__attribute__((inline))*/
+int
+vps_md_reboot_copyout(struct thread *td, struct execve_args *args)
+{
+	vm_offset_t addr;
+	struct proc *p;
+	int error = 0;
+
+	/*
+	 * We push the arguments to execve() onto the
+	 * userspace stack of our process.
+	 */
+	p = td->td_proc;
+	addr = p->p_sysent->sv_usrstack - PAGE_SIZE;
+	if (p->p_vmspace->vm_ssize < 1 /* page */) {
+		/* Should not ever happen in theory ! */
+		return (ENOSPC);
+	}
+
+	if (p->p_sysent == &elf64_freebsd_sysvec) {
+		copyout("/sbin/init", (void *)(addr + 0x40), 11);
+		suword64((void *)(addr + 0x0), (addr + 0x40));
+		suword64((void *)(addr + 0x8), (vm_offset_t)NULL);
+#ifdef COMPAT_FREEBSD32
+	} else if (p->p_sysent == &ia32_freebsd_sysvec) {
+		copyout("/sbin/init", (void *)(addr + 0x40), 11);
+		suword32((void *)(addr + 0x0), (addr + 0x40));
+		suword32((void *)(addr + 0x4), (vm_offset_t)NULL);
+#endif
+	} else {
+		error = EINVAL;
+	}
+
+	args->fname = (char *)(addr + 0x40);
+	args->argv = (char **)addr;
+	args->envv = NULL;
+
+#if 0
+// notyet
+        KASSERT(pargs != NULL,
+            ("%s: vps=%p, lost pargs somewhere, don't know what to boot\n",
+            __func__, vps));
+        arglen = pargs->ar_length;
+        /*
+        if (arglen > PAGE_SIZE)
+                arglen = PAGE_SIZE - 1;
+        copyout(pargs->ar_args, (void *)addr, arglen);
+        subyte((char *)(addr + PAGE_SIZE - 1), 0x0);
+        */
+        if (exec_alloc_args(&imgargs)) {
+                DBGCORE("%s: exec_alloc_args() returned error\n", __func__);
+                pargs_drop(pargs);
+                goto fail;
+        }  
+        if (arglen > PATH_MAX + ARG_MAX)
+                arglen = PATH_MAX + ARG_MAX - 1;
+        memcpy(imgargs.buf, pargs->ar_args, arglen);
+        addr = (vm_offset_t)imgargs.buf;
+        // ---
+        imgargs.fname = (char *)addr;
+        imgargs.begin_argv = (char *)(addr + 0x0);
+        imgargs.begin_envv = (char *)(addr + arglen);
+        imgargs.endp = (char *)(addr + arglen);
+        imgargs.envc = 0;
+        imgargs.argc = 1; /* XXX */
+        imgargs.stringspace = 0;
+#endif
+
+	return (error);
+}
+
+/*__attribute__((noinline))*/
+int
+vps_md_syscall_fixup(struct vps *vps, struct thread *td,
+    register_t *ret_code, register_t **ret_args, int *ret_narg)
+{
+	struct trapframe *frame;
+	struct sysentvec *sv;
+	struct proc *p;
+	register_t code;
+	register_t args[8];
+	int narg;
+	int error = 0;
+	int i;
+	int ia32_emul = 0;
+	int traptype;
+	struct ucred *save_ucred = curthread->td_ucred;
+
+	if (vps_func->vps_access_vmspace == NULL)
+		return (EOPNOTSUPP);
+
+	p = td->td_proc;
+	frame = td->td_frame;
+	sv = p->p_sysent;
+
+	traptype = (frame->cause & MIPS_CR_EXC_CODE) >>
+	    MIPS_CR_EXC_CODE_SHIFT;
+	if (! (traptype == T_SYSCALL && TRAPF_USERMODE(frame))) {
+		DBGCORE("%s: thread %p was not in syscall: "
+		    "traptype=%d\n", __func__, td,
+		    traptype);
+
+		/* nothing to do ? */
+		error = 0;
+		goto out;
+	}
+
+	if (sv == &elf64_freebsd_sysvec) {
+		DBGCORE("%s: proc=%p/%u elf64_freebsd_sysvec\n",
+		    __func__, p, p->p_pid);
+#ifdef COMPAT_FREEBSD32
+	} else if (sv == &ia32_freebsd_sysvec) {
+		DBGCORE("%s: proc=%p/%u ia32_freebsd_sysvec\n",
+		    __func__, p, p->p_pid);
+		ia32_emul = 1;
+#endif
+	} else {
+		DBGCORE("%s: proc=%p/%u unknown sysentvec %p\n",
+		    __func__, p, p->p_pid, sv);
+		panic("%s: proc=%p/%u unknown sysentvec %p\n",
+		    __func__, p, p->p_pid, sv);
+	}
+
+	/* Just in case vm objects are split/copied/... */
+	curthread->td_ucred = td->td_ucred;
+
+	/*
+	 * XXX: special handling for
+	 *      sa->code == SYS_syscall || sa->code == SYS___syscall
+	 */
+
+	memset((caddr_t)args, 0, sizeof(args));
+
+	code = frame->v0;
+
+	if (sv->sv_mask)
+		code &= sv->sv_mask;
+	if (code >= sv->sv_size)
+		code = 0;
+
+	narg = (&sv->sv_table[code])->sy_narg;
+
+	KASSERT(narg * sizeof(register_t) <= sizeof(args),
+	    ("%s: argument space on stack too small, narg=%d\n",
+	    __func__, narg));
+
+	if (ia32_emul) {
+		uint32_t args32[8];
+
+		memset(args32, 0, sizeof(args32));
+
+		for (i = 0; i < narg; i++)
+			args[i] = (uint64_t)args32[i];
+
+	} else {
+
+		args[0] = frame->a0;
+		args[1] = frame->a1;
+		args[2] = frame->a2;
+		args[3] = frame->a3;
+		args[4] = frame->a4;
+		args[5] = frame->a5;
+		args[6] = frame->a6;
+		args[7] = frame->a7;
+
+		for (i = 0; i < 8; i++)
+			if (i >= narg)
+				args[i] = 0;
+
+	}
+
+	DBGCORE("%s: code=%lu/0x%lx narg=%u args: %016lx %016lx %016lx "
+	    "%016lx %016lx %016lx\n", __func__, code, code, narg,
+	    args[0], args[1], args[2], args[3], args[4], args[5]);
+
+	DBGCORE("SYSCALL: tid=%d pid=%d syscall=%ld retval[0]=%zx "
+	    "retval[1]=%zx errno=%d\n",
+	    td->td_tid, td->td_proc->p_pid, code, td->td_retval[0],
+	    td->td_retval[1], td->td_errno);
+
+	KASSERT(*ret_narg >= narg,
+	    ("%s: supplied args array too small (narg=%d *ret_narg=%d)\n",
+	    __func__, narg, *ret_narg));
+	*ret_code = code;
+	*ret_narg= narg;
+	memcpy(ret_args, &args, narg * sizeof(args[0]));
+
+ out:
+	curthread->td_ucred = save_ucred;
+
+	return (error);
+}
+
+int
+vps_md_syscall_fixup_setup_inthread(struct vps *vps, struct thread *td,
+    register_t code)
+{
+
+	DBGCORE("%s\n", __func__);
+
+	if (vps_func->vps_syscall_fixup_inthread == NULL)
+		return (EOPNOTSUPP);
+
+	/*
+	td->td_pcb->pcb_r12 =
+	    (uint64_t)vps_func->vps_syscall_fixup_inthread;
+	td->td_pcb->pcb_rip = (uint64_t)fork_trampoline;
+	td->td_pcb->pcb_rsp = (uint64_t)td->td_frame -
+	    sizeof(void *);
+	td->td_pcb->pcb_rbx = (uint64_t)code;
+	td->td_pcb->pcb_rbp = 0;
+	*/
+	td->td_pcb->pcb_context[PCB_REG_RA] = (register_t)(intptr_t)
+	    fork_trampoline;
+	/* Make sp 64-bit aligned */
+	td->td_pcb->pcb_context[PCB_REG_SP] = (register_t)(((vm_offset_t)
+	    td->td_pcb & ~(sizeof(__int64_t) - 1)) - CALLFRAME_SIZ);
+	td->td_pcb->pcb_context[PCB_REG_S0] = (register_t)(intptr_t)
+	    vps_func->vps_syscall_fixup_inthread;
+	td->td_pcb->pcb_context[PCB_REG_S1] = (register_t)code;
+
+	return (0);
+}
+
+__attribute__((noinline))
+void
+vps_md_print_pcb(struct thread *td)
+{
+        struct pcb *p;
+
+        p = td->td_pcb;
+
+#if 0
+// XXX
+        DBGCORE("%s: td=%p\n"
+                "pcb_cr3: 0x%08x\n"
+                "pcb_edi: 0x%08x\n"
+                "pcb_esi: 0x%08x\n"
+                "pcb_ebp: 0x%08x\n"
+                "pcb_esp: 0x%08x\n"
+                "pcb_ebx: 0x%08x\n"
+                "pcb_eip: 0x%08x\n"
+                "pcb_psl: 0x%08x\n"
+                "pcb_ext: 0x%08x\n"
+                , __func__, td
+                , p->pcb_cr3
+                , p->pcb_edi
+                , p->pcb_esi
+                , p->pcb_ebp
+                , p->pcb_esp
+                , p->pcb_ebx
+                , p->pcb_eip
+                , p->pcb_psl
+                , (int)p->pcb_ext
+                );
+#endif
+}
+
+#if 0
+/* --------------------------- 8< --------------------------- */
+
+// vps_suspend():
+#if defined(CPU_X86)
+              DBGCORE("td->td_frame=%p tf_rax=%p tf_rsp=%p\n", td->td_frame,
+                 (void*)td->td_frame->tf_rax, (void*)td->td_frame->tf_rsp);
+#elif defined(CPU_386)
+              DBGCORE("td->td_frame=%p tf_eax=%p tf_esp=%p\n", td->td_frame,
+                 (void*)td->td_frame->tf_eax, (void*)td->td_frame->tf_esp);
+#else
+#error "unsupported architecture"
+#endif
+
+// 
+/* --------------------------- 8< --------------------------- */
+#endif /* 0 */
+
+#endif /* VPS */
+
+/* EOF */
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/modules/Makefile head/sys/modules/Makefile
--- clean-head/sys/modules/Makefile	2013-06-26 09:35:55.000000000 +0200
+++ head/sys/modules/Makefile	2013-06-24 14:20:48.000000000 +0200
@@ -341,6 +341,15 @@ SUBDIR=	\
 	vkbd \
 	${_vmm} \
 	${_vpo} \
+	vps_dev \
+	vps_suspend \
+	vps_account \
+	vps_snapst \
+	vps_restore \
+	vps_libdump \
+	if_vps \
+	vps_ddb \
+	vpsfs \
 	vr \
 	vte \
 	vx \
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/modules/if_vps/Makefile head/sys/modules/if_vps/Makefile
--- clean-head/sys/modules/if_vps/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/modules/if_vps/Makefile	2013-06-24 14:20:45.000000000 +0200
@@ -0,0 +1,19 @@
+
+.PATH: ${.CURDIR}/../../vps
+
+KMOD=	if_vps
+SRCS=	if_vps.c opt_ddb.h opt_vps.h opt_inet.h opt_inet6.h vps.h vps_user.h
+
+.if !defined(KERNBUILDDIR)
+opt_ddb.h:
+	echo "#define DDB 1" > ${.TARGET}
+
+opt_inet.h:
+        echo "#define INET 1" > ${.TARGET}
+
+opt_inet6.h:
+        echo "#define INET6 1" > ${.TARGET}
+
+.endif
+
+.include <bsd.kmod.mk>
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/modules/vps_account/Makefile head/sys/modules/vps_account/Makefile
--- clean-head/sys/modules/vps_account/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/modules/vps_account/Makefile	2013-06-24 14:20:49.000000000 +0200
@@ -0,0 +1,13 @@
+
+.PATH: ${.CURDIR}/../../vps
+
+KMOD=	vps_account
+SRCS=	vps_account.c opt_ddb.h opt_global.h opt_vps.h \
+	vnode_if.h vps.h vps_account.h
+
+.if !defined(KERNBUILDDIR)
+opt_ddb.h:
+	echo "#define DDB 1" > ${.TARGET}
+.endif
+
+.include <bsd.kmod.mk>
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/modules/vps_ddb/Makefile head/sys/modules/vps_ddb/Makefile
--- clean-head/sys/modules/vps_ddb/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/modules/vps_ddb/Makefile	2013-06-24 14:20:45.000000000 +0200
@@ -0,0 +1,19 @@
+
+.PATH: ${.CURDIR}/../../vps
+
+KMOD=	vps_ddb
+SRCS=	vps_ddb.c opt_ddb.h opt_inet.h opt_inet6.h vps.h vps_user.h vps_snapst.h
+
+.if !defined(KERNBUILDDIR)
+opt_ddb.h:
+	echo "#define DDB 1" > ${.TARGET}
+
+opt_inet.h:
+        echo "#define INET 1" > ${.TARGET}
+
+opt_inet6.h:
+        echo "#define INET6 1" > ${.TARGET}
+
+.endif
+
+.include <bsd.kmod.mk>
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/modules/vps_dev/Makefile head/sys/modules/vps_dev/Makefile
--- clean-head/sys/modules/vps_dev/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/modules/vps_dev/Makefile	2013-06-24 14:20:45.000000000 +0200
@@ -0,0 +1,12 @@
+
+.PATH: ${.CURDIR}/../../vps
+
+KMOD=	vps_dev
+SRCS=	vps_dev.c vps_user.c opt_ddb.h opt_global.h opt_vps.h vps.h vps_user.h
+
+.if !defined(KERNBUILDDIR)
+opt_ddb.h:
+	echo "#define DDB 1" > ${.TARGET}
+.endif
+
+.include <bsd.kmod.mk>
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/modules/vps_libdump/Makefile head/sys/modules/vps_libdump/Makefile
--- clean-head/sys/modules/vps_libdump/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/modules/vps_libdump/Makefile	2013-06-24 14:20:45.000000000 +0200
@@ -0,0 +1,14 @@
+
+.PATH: ${.CURDIR}/../../vps
+
+KMOD=	vps_libdump
+SRCS=	vps_libdump.c \
+	vps_libdump.h \
+	opt_ddb.h opt_vps.h opt_inet.h opt_inet6.h \
+	vnode_if.h
+
+.if !defined(KERNBUILDDIR)
+
+.endif
+
+.include <bsd.kmod.mk>
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/modules/vps_restore/Makefile head/sys/modules/vps_restore/Makefile
--- clean-head/sys/modules/vps_restore/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/modules/vps_restore/Makefile	2013-06-24 14:20:53.000000000 +0200
@@ -0,0 +1,25 @@
+
+.PATH: ${.CURDIR}/../../vps
+
+KMOD=	vps_restore
+SRCS=	vps_restore.c \
+	vps.h vps_user.h vps_snapst.h vps_libdump.h \
+	opt_ddb.h opt_vps.h opt_inet.h opt_inet6.h \
+	vnode_if.h
+
+.if !defined(KERNBUILDDIR)
+opt_vps.h:
+	echo "#define VPS 1" > ${.TARGET}
+
+opt_ddb.h:
+	echo "#define DDB 1" > ${.TARGET}
+
+opt_inet.h:
+        echo "#define INET 1" > ${.TARGET}
+
+opt_inet6.h:
+        echo "#define INET6 1" > ${.TARGET}
+
+.endif
+
+.include <bsd.kmod.mk>
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/modules/vps_snapst/Makefile head/sys/modules/vps_snapst/Makefile
--- clean-head/sys/modules/vps_snapst/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/modules/vps_snapst/Makefile	2013-06-24 14:20:48.000000000 +0200
@@ -0,0 +1,25 @@
+
+.PATH: ${.CURDIR}/../../vps
+
+KMOD=	vps_snapst
+SRCS=	vps_snapst.c \
+	vps.h vps_user.h vps_snapst.h vps_libdump.h \
+	opt_ddb.h opt_vps.h opt_inet.h opt_inet6.h \
+	vnode_if.h
+
+.if !defined(KERNBUILDDIR)
+opt_vps.h:
+	echo "#define VPS 1" > ${.TARGET}
+
+opt_ddb.h:
+	echo "#define DDB 1" > ${.TARGET}
+
+opt_inet.h:
+        echo "#define INET 1" > ${.TARGET}
+
+opt_inet6.h:
+        echo "#define INET6 1" > ${.TARGET}
+
+.endif
+
+.include <bsd.kmod.mk>
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/modules/vps_suspend/Makefile head/sys/modules/vps_suspend/Makefile
--- clean-head/sys/modules/vps_suspend/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/modules/vps_suspend/Makefile	2013-06-24 14:20:45.000000000 +0200
@@ -0,0 +1,8 @@
+
+.PATH: ${.CURDIR}/../../vps
+
+KMOD=	vps_suspend
+SRCS=	vps_suspend.c opt_ddb.h opt_vps.h opt_inet.h opt_inet6.h opt_compat.h \
+	vnode_if.h vps.h vps_user.h vps_snapst.h
+
+.include <bsd.kmod.mk>
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/modules/vpsfs/Makefile head/sys/modules/vpsfs/Makefile
--- clean-head/sys/modules/vpsfs/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/modules/vpsfs/Makefile	2013-06-24 14:20:48.000000000 +0200
@@ -0,0 +1,8 @@
+
+.PATH: ${.CURDIR}/../../fs/vpsfs
+
+KMOD=	vpsfs
+SRCS=	vnode_if.h \
+	vpsfs_subr.c vpsfs_vfsops.c vpsfs_vnops.c vpsfs_quota.c
+
+.include <bsd.kmod.mk>
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/net/bpf.c head/sys/net/bpf.c
--- clean-head/sys/net/bpf.c	2013-06-26 09:37:38.000000000 +0200
+++ head/sys/net/bpf.c	2013-06-24 14:21:35.000000000 +0200
@@ -78,6 +78,8 @@ __FBSDID("$FreeBSD: head/sys/net/bpf.c 2
 #include <net/bpfdesc.h>
 #include <net/vnet.h>
 
+#include <vps/vps.h>
+
 #include <netinet/in.h>
 #include <netinet/if_ether.h>
 #include <sys/kernel.h>
@@ -2245,7 +2247,7 @@ bpf_bintime2ts(struct bintime *bt, struc
 
 	if ((tstype & BPF_T_MONOTONIC) == 0) {
 		bt2 = *bt;
-		bintime_add(&bt2, &boottimebin);
+		bintime_add(&bt2, &V_boottimebin);
 		bt = &bt2;
 	}
 	switch (BPF_T_FORMAT(tstype)) {
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/net/flowtable.c head/sys/net/flowtable.c
--- clean-head/sys/net/flowtable.c	2013-06-26 09:37:38.000000000 +0200
+++ head/sys/net/flowtable.c	2013-06-24 14:21:35.000000000 +0200
@@ -272,6 +272,7 @@ SYSCTL_VNET_INT(_net_inet_flowtable, OID
     &VNET_NAME(flowtable_tcp_expire), 0,
     "seconds after which to remove flow allocated to a TCP connection.");
 
+MALLOC_DEFINE(M_FLOWTBL, "flowtbl", "flowtable");
 
 /*
  * Maximum number of flows that can be allocated of a given type.
@@ -1308,7 +1309,7 @@ flowtable_alloc(char *name, int nentry, 
 	KASSERT(nentry > 0, ("nentry must be > 0, is %d\n", nentry));
 
 	ft = malloc(sizeof(struct flowtable),
-	    M_RTABLE, M_WAITOK | M_ZERO);
+	    M_FLOWTBL, M_WAITOK | M_ZERO);
 
 	ft->ft_name = name;
 	ft->ft_flags = flags;
@@ -1325,7 +1326,7 @@ flowtable_alloc(char *name, int nentry, 
 		for (i = 0; i <= mp_maxid; i++) {
 			ft->ft_table.pcpu[i] =
 			    malloc(nentry*sizeof(struct flentry *),
-				M_RTABLE, M_WAITOK | M_ZERO);
+				M_FLOWTBL, M_WAITOK | M_ZERO);
 			ft->ft_masks[i] = bit_alloc(nentry);
 		}
 	} else {
@@ -1336,9 +1337,9 @@ flowtable_alloc(char *name, int nentry, 
 		ft->ft_unlock = flowtable_global_unlock;
 		ft->ft_table.global =
 			    malloc(nentry*sizeof(struct flentry *),
-				M_RTABLE, M_WAITOK | M_ZERO);
+				M_FLOWTBL, M_WAITOK | M_ZERO);
 		ft->ft_locks = malloc(ft->ft_lock_count*sizeof(struct mtx),
-				M_RTABLE, M_WAITOK | M_ZERO);
+				M_FLOWTBL, M_WAITOK | M_ZERO);
 		for (i = 0; i < ft->ft_lock_count; i++)
 			mtx_init(&ft->ft_locks[i], "flow", NULL, MTX_DEF|MTX_DUPOK);
 
@@ -1378,6 +1379,82 @@ flowtable_alloc(char *name, int nentry, 
 }
 
 /*
+ * Since this is called from ip_destroy it is assumed
+ * that there will be no more access and thus no locking
+ * required.
+ */
+static bitstr_t * flowtable_mask_pcpu(struct flowtable *ft, int cpuid);
+static struct flentry ** flowtable_entry_pcpu(struct flowtable *ft, uint32_t hash, int cpuid);
+static void fle_free(struct flentry *fle, struct flowtable *ft);
+void
+flowtable_destroy(struct flowtable *ft)
+{
+	struct flowtable *ft2;
+	struct flentry *fle, **flehead;
+	bitstr_t *mask, *tmpmask;
+	int curbit = 0;
+	int cpuid;
+	int i;
+
+	/* Free all entries. */
+	/* XXX not sure if this code actually works because
+	       in my tests there were never entries left at this
+	       point so the code didn't do anything.
+	 */
+
+	for (cpuid = 0; cpuid <= mp_maxid; cpuid++) {
+		
+		mask = flowtable_mask_pcpu(ft, cpuid);
+		tmpmask = ft->ft_tmpmask;
+		memcpy(tmpmask, mask, ft->ft_size/8);
+		bit_ffs(tmpmask, ft->ft_size, &curbit);
+
+		while (curbit != -1) {
+			flehead = flowtable_entry_pcpu(ft, curbit, cpuid);
+			fle = *flehead;
+
+			while (fle != NULL) {
+				fle = fle->f_next;
+				fle_free(fle, ft);
+			}
+			bit_clear(tmpmask, curbit);
+			bit_ffs(tmpmask, ft->ft_size, &curbit);
+		}
+	}
+
+	KASSERT(ft->ft_count == 0, ("%s: ft=%p ft->ft_count=%d\n",
+		__func__, ft, ft->ft_count));
+
+	/* Remove from the cleaner list */
+	if (V_flow_list_head) {
+		ft2 = V_flow_list_head;
+		while (ft2 && ft != ft2 && ft2->ft_next != ft)
+			ft2 = ft2->ft_next;
+		if (ft == V_flow_list_head)
+			V_flow_list_head = ft2;
+		if (ft2 != NULL)
+			ft2->ft_next = ft->ft_next;
+	}
+
+	free(ft->ft_tmpmask, M_DEVBUF);
+
+	if (ft->ft_flags & FL_PCPU) {
+		for (i = 0; i <= mp_maxid; i++) {
+			free(ft->ft_masks[i], M_DEVBUF);
+			free(ft->ft_table.pcpu[i], M_FLOWTBL);
+		}
+	} else {
+		free(ft->ft_masks[0], M_DEVBUF);
+		for (i = 0; i < ft->ft_lock_count; i++)
+			mtx_destroy(&ft->ft_locks[i]);
+		free(ft->ft_locks, M_FLOWTBL);
+		free(ft->ft_table.global, M_FLOWTBL);
+	}
+
+	free(ft, M_FLOWTBL);
+}
+
+/*
  * The rest of the code is devoted to garbage collection of expired entries.
  * It is a new additon made necessary by the switch to dynamically allocating
  * flow tables.
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/net/flowtable.h head/sys/net/flowtable.h
--- clean-head/sys/net/flowtable.h	2013-06-26 09:37:38.000000000 +0200
+++ head/sys/net/flowtable.h	2013-06-24 14:21:35.000000000 +0200
@@ -57,6 +57,7 @@ VNET_DECLARE(struct flowtable *, ip6_ft)
 #define	V_ip6_ft		VNET(ip6_ft)
 
 struct flowtable *flowtable_alloc(char *name, int nentry, int flags);
+void flowtable_destroy(struct flowtable *);
 
 /*
  * Given a flow table, look up the L3 and L2 information and
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/net/if.c head/sys/net/if.c
--- clean-head/sys/net/if.c	2013-06-26 09:37:39.000000000 +0200
+++ head/sys/net/if.c	2013-06-24 14:21:35.000000000 +0200
@@ -73,6 +73,9 @@
 #include <net/route.h>
 #include <net/vnet.h>
 
+#include <vps/vps.h>
+#include <vps/vps2.h>
+
 #if defined(INET) || defined(INET6)
 #include <netinet/in.h>
 #include <netinet/in_var.h>
@@ -674,6 +677,12 @@ if_attach_internal(struct ifnet *ifp, in
 			if (ifa->ifa_addr->sa_family == AF_LINK) {
 				sdl = (struct sockaddr_dl *)ifa->ifa_addr;
 				sdl->sdl_index = ifp->if_index;
+#ifdef VPS
+				namelen = strlen(ifp->if_xname);
+				sdl->sdl_nlen = namelen;
+				bcopy(ifp->if_xname, sdl->sdl_data, namelen);
+				/* XXX --> netmask ... */
+#endif
 			}
 		}
 	}
@@ -1072,6 +1081,46 @@ if_vmove_reclaim(struct thread *td, char
 	prison_free(pr);
 	return (0);
 }
+
+#ifdef VPS
+int
+if_vmove_vps(struct thread *td, char *ifname, size_t ifname_size, struct vps *vps, char *newifname)
+{
+	struct ifnet *ifp;
+	struct ifnet *difp;
+
+	ifp = ifunit(ifname);
+	if (ifp == NULL)
+		return (ESRCH);
+
+	/* Do not try to move the iface from and to the same vnet. */
+	if (vps->vnet == ifp->if_vnet)
+		return (EEXIST);
+
+	/* Make sure the named iface does not exists in the dst. vnet. */
+	/* XXX Lock interfaces to avoid races. */
+	CURVNET_SET_QUIET(vps->vnet);
+	difp = ifunit(newifname != NULL ? newifname : ifname);
+	CURVNET_RESTORE();
+	if (difp != NULL)
+		return (EEXIST);
+
+	/* XXX Make sure there are no unwanted side effects. */
+	DBGCORE("%s: newifname=%p\n", __func__, newifname);
+	if (newifname != NULL) {
+		DBGCORE("%s: newifname=[%s]\n", __func__, newifname);
+		snprintf(ifp->if_xname, sizeof(ifp->if_xname), "%s", newifname);	
+	}
+
+	/* Move the interface into the child vnet. */
+	if_vmove(ifp, vps->vnet);
+
+	/* Report the new if_xname back to the userland. */
+	snprintf(ifname, ifname_size, "%s", ifp->if_xname);
+
+	return (0);
+}
+#endif /* VPS */
 #endif /* VIMAGE */
 
 /*
@@ -2617,7 +2666,16 @@ ifioctl(struct socket *so, u_long cmd, c
 		if (ifp->if_flags & IFF_UP)
 			in6_if_up(ifp);
 #endif
+
 	}
+
+#ifdef VPS
+	if (ifp->if_pspare[2] != NULL)
+		((void (*) (u_long cmd, caddr_t data,
+			struct ifnet *ifp, struct thread *td))
+			ifp->if_pspare[2])(cmd, data, ifp, td);
+#endif
+
 	if_rele(ifp);
 	CURVNET_RESTORE();
 	return (error);
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/net/if_llatbl.h head/sys/net/if_llatbl.h
--- clean-head/sys/net/if_llatbl.h	2013-06-26 09:37:38.000000000 +0200
+++ head/sys/net/if_llatbl.h	2013-06-24 14:21:35.000000000 +0200
@@ -172,6 +172,7 @@ MALLOC_DECLARE(M_LLTABLE);
 #define	LLE_STATIC	0x0002	/* entry is static */
 #define	LLE_IFADDR	0x0004	/* entry is interface addr */
 #define	LLE_VALID	0x0008	/* ll_addr is valid */
+#define LLE_PROXY       0x0010  /* proxy entry ??? */
 #define	LLE_PUB		0x0020	/* publish entry ??? */
 #define	LLE_LINKED	0x0040	/* linked to lookup structure */
 #define	LLE_EXCLUSIVE	0x2000	/* return lle xlocked  */
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/net/if_tun.c head/sys/net/if_tun.c
--- clean-head/sys/net/if_tun.c	2013-06-26 09:37:39.000000000 +0200
+++ head/sys/net/if_tun.c	2013-06-24 14:21:35.000000000 +0200
@@ -56,6 +56,8 @@
 #include <net/bpf.h>
 #include <net/if_tun.h>
 
+#include <vps/vps.h>
+
 #include <sys/queue.h>
 #include <sys/condvar.h>
 
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/net/if_var.h head/sys/net/if_var.h
--- clean-head/sys/net/if_var.h	2013-06-26 09:37:39.000000000 +0200
+++ head/sys/net/if_var.h	2013-06-24 14:21:35.000000000 +0200
@@ -216,7 +216,7 @@ struct ifnet {
 	 */
 	char	if_cspare[3];
 	int	if_ispare[4];
-	void	*if_pspare[8];		/* 1 netmap, 7 TDB */
+	void	*if_pspare[8];		/* 1 netmap, 7 TDB, 2 VPS */
 };
 
 typedef void if_init_f_t(void *);
@@ -965,6 +965,10 @@ int    ether_poll_register(poll_handler_
 int    ether_poll_deregister(struct ifnet *ifp);
 #endif /* DEVICE_POLLING */
 
+#ifdef VPS
+int if_vmove_vps(struct thread *td, char *ifname, size_t ifname_size, struct vps *vps, char *);
+#endif
+
 #endif /* _KERNEL */
 
 #endif /* !_NET_IF_VAR_H_ */
